routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\CartController;
use App\Http\Controllers\DishController;
use Illuminate\Support\Facades\Auth;
use App\Http\Controllers\CafeController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [CafeController::class, 'index']);

Route::resource('cafes', CafeController::class)
    ->only(['index', 'show']);
Route::resource('dishes', DishController::class)
    ->only(['index', 'show']);
Route::post('cart/{dish}', [CartController::class, 'add'])
    ->name('cart.add');
Route::delete('cart/{dish}', [CartController::class, 'remove'])
    ->name('cart.remove');

Auth::routes();

Route::prefix('admin')->name('admin.')
    ->middleware(['auth', 'is_admin'])->group( function () {
    Route::resources([
        'dishes' => Admin\DishesController::class,
        'cafes' => Admin\CafesController::class,
        'users' => Admin\UserController::class
    ]);
});

app/Models/Cafe.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static paginate(int $int)
 */
class Cafe extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'description', 'image'];

    public function dishes(): HasMany
    {
        return $this->hasMany(Dish::class);
    }
}

app/Http/Controllers/Admin/CafesController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\CafeRequest;
use App\Models\Cafe;
use App\Models\Dish;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;
use Intervention\Image\Facades\Image;

class CafesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index(): View|Factory|Application
    {
        $cafes = Cafe::all();
        return view('admin.cafes.index', compact('cafes'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create(): View|Factory|Application
    {
        return view('admin.cafes.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CafeRequest $request
     * @return RedirectResponse
     */
    public function store(CafeRequest $request): RedirectResponse
    {
        $data = $request->validated();
        if ($request->hasFile('image')) {
            $data['image'] = $request->file('image')->store('pictures/cafes', 'public');
        }
        Cafe::create(array_merge($data, ['user_id' => Auth::id()]));
        return redirect()->route('admin.cafes.index')->with('message', 'Новое кафе добалено!');
    }

    /**
     * Display the specified resource.
     *
     * @param Cafe $cafe
     * @return Application|Factory|View
     */
    public function show(Cafe $cafe): View|Factory|Application
    {
        $dishes = Dish::where('cafe_id', $cafe->id)->get();
        return view('admin.cafes.show', compact('cafe', 'dishes'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Cafe $cafe
     * @return Application|Factory|View
     */
    public function edit(Cafe $cafe): View|Factory|Application
    {

        return view('admin.cafes.edit', compact('cafe'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param CafeRequest $request
     * @param Cafe $cafe
     * @return RedirectResponse
     */
    public function update(CafeRequest $request, Cafe $cafe): RedirectResponse
    {
        $data = $request->validated();
        if ($request->hasFile('image')) {
            $file = $request->file('image');
            $path = $file->store('pictures/cafes', 'public');
            $data['image'] = $path;
        }
        $cafe->update($data);
        return redirect()->route('admin.cafes.index', compact('cafe'))->with('message', 'Кафе обновлено!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Cafe $cafe
     * @return RedirectResponse
     */
    public function destroy(Cafe $cafe): RedirectResponse
    {
        $cafe->delete();
        return redirect()->route('admin.cafes.index')->with('message', 'Кафе успешно удалено!');
    }
}

app/Http/Controllers/CafeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Cafe;
use App\Models\Dish;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;

class CafeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index(): View|Factory|Application
    {
        $cafes = Cafe::paginate(6);
        return view('cafes.index', compact('cafes'));
    }

    /**
     * Display the specified resource.
     *
     * @param Cafe $cafe
     * @return Application|Factory|View
     */
    public function show(Cafe $cafe): View|Factory|Application
    {
        $sessionData = session()->get('cart.'. $cafe->id, []);
        $totalPrice = 0;
        foreach ($sessionData as &$item) {
            $item['dish'] = Dish::find($item['dish_id']);
            $totalPrice += $item['dish']->price * $item['quantity'];
        }
        $cart = [
            'dishes' => $sessionData,
            'total_price' => $totalPrice
        ];
        return view('cafes.show', compact('cafe', 'cart'));
    }
}

resources/views/admin/cafes/create.blade.php
@extends('layouts.app')
@section('content')
    <h3 class="mt-5">Создать новое кафе</h3>
    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{route('admin.cafes.store')}}" method="post" enctype="multipart/form-data">
        @csrf
        <div class="mb-3">
            <label>
                Название
                <input type="text" class="form-control" name="name" value="{{old('name')}}">
                @error('name')
                <div class="alert alert-danger">{{$message}}</div>
                @enderror
            </label>
        </div>

        <div class="mb-3">
            <label>
                Описание
                <textarea name="description" cols="20" rows="3"
                          class="form-control">{{old('description')}}</textarea>
                @error('description')
                <div class="alert alert-danger">{{$message}}</div>
                @enderror
            </label>
        </div>

        <div class="mb-3">
            <label>
                <input type="file" required name="image" class="form-control" value="{{old('image')}}">
                @error('image')
                <div class="alert alert-danger">{{$message}}</div>
                @enderror
            </label>
        </div>

        <button class="btn btn-success">Принять</button>
    </form>
@endsection

resources/views/admin/cafes/edit.blade.php
@extends('layouts.app')


@section('content')
    <h3 class="mt-5">Создать новое кафе</h3>
    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{route('admin.cafes.update', compact('cafe'))}}" method="post" enctype="multipart/form-data">
        @csrf
        @method('put')
        <div class="mb-3">
            <label>
                Название
                <input type="text" class="form-control" name="name" value="{{$cafe->name}}">
            </label>
        </div>

        <div class="mb-3">
            <label>
                Описание
                <textarea name="description" cols="20" rows="3"
                          class="form-control">{{$cafe->description}}</textarea>
            </label>
        </div>

        <img class="mb-3" src="{{asset('/storage/' . $cafe->image)}}" alt="{{$cafe->image}}" style="width:300px;height:230px;">
        <br>
        <div class="mb-3">
            <label>
                <input type="file" required name="image" class="form-control" value="{{old($cafe->image)}}">
            </label>
        </div>

        <button class="btn btn-success">Принять</button>
    </form>
@endsection

resources/views/admin/cafes/index.blade.php
@extends('layouts.app')

@section('content')
    <h3 class="mt-5">КаФе</h3>
    @if (session('message'))
        <div class="alert alert-success mb-3" role="alert">
            {{ session('message') }}
        </div>
    @endif
    <a href="{{route('admin.cafes.create')}}">Создать новое кафе</a>
    <table class="table">
        <thead>
            <tr>

                <th scope="col">Фото</th>
                <th scope="col">Название</th>
                <th scope="col">Описание</th>
                <th scope="col">Действие</th>
            </tr>
        </thead>

        <tbody>
        @foreach($cafes as $cafe)
            <tr>
                <td><img class="card-img-top" src="{{asset('storage/' . $cafe->image)}}" alt="{{$cafe->image}}" style="width: 250px"></td>
                <td>{{$cafe->name}}</td>
                <td>{{$cafe->description}}</td>
                <td>
                    <div class="d-flex">
                        <a href="{{route('admin.cafes.show', compact('cafe'))}}" class="btn btn-secondary me-3">Показать</a>
                        <a href="{{route('admin.cafes.edit', compact('cafe'))}}" class="btn btn-primary me-3">Изменить</a>
                        <form action="{{route('admin.cafes.destroy', compact('cafe'))}}" method="post">
                            @csrf
                            @method('delete')
                            <button type="submit" class="btn btn-danger">Удалить</button>
                        </form>
                    </div>
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>


@endsection

resources/views/admin/cafes/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container mb-4">
        <h2>Тут можно вкусно поесть</h2>
    </div>
    <div class="card " style="width: 24rem;">
        <div class="card-header">
            Деталь жанра: {{$cafe->name}}
        </div>
        <img class="card-img-top" src="{{asset('storage/' . $cafe->image)}}" alt="{{$cafe->image}}">

        <div class="card-body">
            <h5 class="card-title">{{$cafe->description}}</h5>
            <a href="{{route('admin.cafes.index')}}" class="btn btn-default btn-sm">Назад</a>|
            <a href="{{route('admin.cafes.edit', ['cafe' => $cafe])}}" class="btn btn-primary btn-sm">Изменить</a>
        </div>
    </div>

    <p class="mt-5 mb-5">{{$cafe->desc}}</p>

    <h1 class="mb-4">Блюдa в ассортименте</h1>

    @include('admin.parties.index')

@endsection